/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc.lexer;

import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.PushbackReader;

import org.sablecc.sablecc.node.*;

public class Lexer
{
    protected Token token;
    protected State state = State.NORMAL;

    private final PushbackReader in;
    protected int line;
    protected int pos;
    private boolean cr;
    private boolean eof;
    private final StringBuilder text = new StringBuilder();

    protected void filter() throws LexerException, IOException
    {}

    public Lexer(PushbackReader in)
    {
        this.in = in;
    }

    public Token peek() throws LexerException, IOException
    {
        while(this.token == null)
        {
            token = getToken();
            filter();
        }

        return token;
    }

    public Token next() throws LexerException, IOException
    {
        while(this.token == null)
        {
            token = getToken();
            filter();
        }

        Token result = token;
        token = null;
        return result;
    }

    protected Token getToken() throws IOException, LexerException
    {
        int dfaState = 0;

        int startPos = this.pos;
        int startLine = this.line;

        int acceptState = -1;
        int acceptToken = -1;
        int acceptLength = -1;
        int acceptPos = -1;
        int acceptLine = -1;
        boolean acceptCr = false;

        int[][][] gotoTableSub = Lexer.gotoTable[this.state.ordinal()];
        int[] acceptSub = Lexer.accept[this.state.ordinal()];
        this.text.setLength(0);

        while(true)
        {
            int c = getChar();

            if(c != -1)
            {
                switch(c)
                {
                    case '\n':
                        if(this.cr)
                        {
                            // If the preceding character was \r (CR),
                            // ignore this \n (LF) character and don't increase the line or column.
                            this.cr = false;
                        }
                        else
                        {
                            // If there was no preceding \r (CR) character,
                            // consider this \n (LF) character an actual newline.
                            this.line++;
                            this.pos = 0;
                        }
                        break;
                    case '\r':
                        // A \r (CR) character is always considered a newline,
                        // but a \n (LF) character following it (if any) will be ignored (see above).
                        this.line++;
                        this.pos = 0;
                        this.cr = true;
                        break;
                    case 0x2028: // Unicode line separator
                    case 0x2029: // Unicode paragraph separator
                        // A Unicode line or paragraph separator is treated like a newline,
                        // but doesn't take part in the special handling for CR+LF.
                        // FIXME This case is a workaround for a limitation in the ProB cliparser prepl protocol, which doesn't support embedded newlines.
                        // TODO Remove this case once that is resolved. Practically nothing else uses the Unicode line separator character.
                        this.line++;
                        this.pos = 0;
                        this.cr = false;
                        break;
                    default:
                        this.pos++;
                        this.cr = false;
                        break;
                }

                this.text.append((char) c);

                do
                {
                    int oldState = (dfaState < -1) ? (-2 -dfaState) : dfaState;

                    dfaState = -1;

                    int[][] tmp1 = gotoTableSub[oldState];
                    int low = 0;
                    int high = tmp1.length - 1;

                    // find next DFA state depending on character c
                    // an entry {Low, Up, Id} -> means if Low <= c <= Up -> goto state Id
                    while(low <= high)
                    {
                        int middle = (low + high) >>> 1;
                        int[] tmp2 = tmp1[middle];

                        if(c < tmp2[0])
                        {
                            high = middle - 1;
                        }
                        else if(c > tmp2[1])
                        {
                            low = middle + 1;
                        }
                        else
                        {
                            dfaState = tmp2[2];
                            break;
                        }
                    }
                } while(dfaState < -1);
            }
            else
            {
                dfaState = -1;
            }

            if(dfaState >= 0)
            {
                if(acceptSub[dfaState] != -1)
                {
                    acceptState = dfaState;
                    acceptToken = acceptSub[dfaState];
                    acceptLength = this.text.length();
                    acceptPos = this.pos;
                    acceptLine = this.line;
                    acceptCr = this.cr;
                }
            }
            else
            {
                if(acceptState != -1)
                {
                    Token tok;
                    switch(acceptToken)
                    {
                        case 0:
                            tok = new TPkgId(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            switch(state.ordinal())
                            {
                                case 1: state = State.PACKAGE; break;
                            }
                            break;

                        case 1:
                            tok = new TPackage(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            switch(state.ordinal())
                            {
                                case 0: state = State.PACKAGE; break;
                            }
                            break;

                        case 2:
                            tok = new TStates(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 3:
                            tok = new THelpers(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 4:
                            tok = new TTokens(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 5:
                            tok = new TIgnored(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 6:
                            tok = new TProductions(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 7:
                            tok = new TAbstract(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 8:
                            tok = new TSyntax(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 9:
                            tok = new TTree(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 10:
                            tok = new TNew(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 11:
                            tok = new TNull(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 12:
                            tok = new TTokenSpecifier(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 13:
                            tok = new TProductionSpecifier(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 14:
                            tok = new TDot(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 15:
                            tok = new TDDot(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 16:
                            tok = new TSemicolon(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            switch(state.ordinal())
                            {
                                case 0: state = State.NORMAL; break;
                                case 1: state = State.NORMAL; break;
                            }
                            break;

                        case 17:
                            tok = new TEqual(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 18:
                            tok = new TLBkt(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 19:
                            tok = new TRBkt(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 20:
                            tok = new TLPar(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 21:
                            tok = new TRPar(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 22:
                            tok = new TLBrace(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 23:
                            tok = new TRBrace(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 24:
                            tok = new TPlus(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 25:
                            tok = new TMinus(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 26:
                            tok = new TQMark(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 27:
                            tok = new TStar(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 28:
                            tok = new TBar(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 29:
                            tok = new TComma(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 30:
                            tok = new TSlash(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 31:
                            tok = new TArrow(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 32:
                            tok = new TColon(startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 33:
                            tok = new TId(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 34:
                            tok = new TChar(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 35:
                            tok = new TDecChar(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 36:
                            tok = new THexChar(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 37:
                            tok = new TString(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 38:
                            tok = new TBlank(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        case 39:
                            tok = new TComment(getText(acceptLength), startLine + 1, startPos + 1);
                            pushBack(acceptLength);
                            this.pos = acceptPos;
                            this.line = acceptLine;
                            this.cr = acceptCr;
                            break;

                        default:
                            throw new LexerException("[" + (startLine + 1) + "," + (startPos + 1) + "] Internal lexer error: invalid accept table entry " + acceptToken + ", current text: " + this.text);
                    }
                    return tok;
                }
                else
                {
                    if(this.text.length() > 0)
                    {
                        throw new LexerException("[" + (startLine + 1) + "," + (startPos + 1) + "] Unknown token: " + this.text);
                    }

                    return new EOF(startLine + 1, startPos + 1);
                }
            }
        }
    }

    private int getChar() throws IOException
    {
        if(this.eof)
        {
            return -1;
        }

        int result = this.in.read();

        if(result == -1)
        {
            this.eof = true;
        }

        return result;
    }

    private void pushBack(int acceptLength) throws IOException
    {
        int length = this.text.length();
        for(int i = length - 1; i >= acceptLength; i--)
        {
            this.eof = false;

            this.in.unread(this.text.charAt(i));
        }
    }

    /**
     * @deprecated This method doesn't restore line/column info correctly in some cases
     *     (if a token begins in the middle of a CRLF newline pair).
     *     There is no planned replacement.
     * @param tok the token to push back onto the input
     * @throws IOException when thrown by {@link PushbackReader#unread(int)}
     */
    @Deprecated
    protected void unread(Token tok) throws IOException
    {
        String text = tok.getText();
        int length = text.length();

        for(int i = length - 1; i >= 0; i--)
        {
            this.eof = false;

            this.in.unread(text.charAt(i));
        }

        this.pos = tok.getPos() - 1;
        this.line = tok.getLine() - 1;
    }

    private String getText(int acceptLength)
    {
        return this.text.substring(0, acceptLength);
    }

    private static final int[][][][] gotoTable;
/*  {
        { // NORMAL
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {39, 39, 5}, {40, 40, 6}, {41, 41, 7}, {42, 42, 8}, {43, 43, 9}, {44, 44, 10}, {45, 45, 11}, {46, 46, 12}, {47, 47, 13}, {48, 48, 14}, {49, 57, 15}, {58, 58, 16}, {59, 59, 17}, {61, 61, 18}, {63, 63, 19}, {65, 65, 20}, {72, 72, 21}, {73, 73, 22}, {78, 78, 23}, {80, 80, 24}, {83, 83, 25}, {84, 84, 26}, {91, 91, 27}, {93, 93, 28}, {97, 122, 29}, {123, 123, 30}, {124, 124, 31}, {125, 125, 32}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 33}, {13, 32, -2}, },
            {{9, 32, -2}, },
            {{0, 9, 34}, {11, 12, 34}, {14, 38, 34}, {39, 39, 35}, {40, 65535, 34}, },
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 36}, },
            {{46, 46, 37}, },
            {{42, 42, 38}, {47, 47, 39}, },
            {{48, 57, 15}, {88, 88, 40}, {120, 120, 41}, },
            {{48, 57, 15}, },
            {},
            {},
            {},
            {},
            {{98, 98, 42}, },
            {{101, 101, 43}, },
            {{103, 103, 44}, },
            {{101, 101, 45}, {117, 117, 46}, },
            {{97, 97, 47}, {114, 114, 48}, },
            {{116, 116, 49}, {121, 121, 50}, },
            {{111, 111, 51}, {114, 114, 52}, },
            {},
            {},
            {{48, 57, 53}, {95, 95, 54}, {97, 122, 55}, },
            {},
            {},
            {},
            {{9, 32, -2}, },
            {{0, 9, 56}, {11, 12, 56}, {14, 38, 56}, {39, 39, 57}, {40, 65535, 56}, },
            {{39, 39, 58}, },
            {},
            {},
            {{0, 41, 59}, {42, 42, 60}, {43, 65535, 59}, },
            {{0, 9, 61}, {10, 10, 62}, {11, 12, 61}, {13, 13, 63}, {14, 65535, 61}, },
            {{48, 57, 64}, {65, 70, 64}, {97, 102, 64}, },
            {{48, 102, -42}, },
            {{115, 115, 65}, },
            {{108, 108, 66}, },
            {{110, 110, 67}, },
            {{119, 119, 68}, },
            {{108, 108, 69}, },
            {{99, 99, 70}, },
            {{111, 111, 71}, },
            {{97, 97, 72}, },
            {{110, 110, 73}, },
            {{107, 107, 74}, },
            {{101, 101, 75}, },
            {{48, 122, -31}, },
            {{97, 122, 76}, },
            {{48, 122, -31}, },
            {{0, 38, -36}, {39, 39, 77}, {40, 65535, 56}, },
            {},
            {},
            {{0, 65535, -40}, },
            {{0, 41, 78}, {42, 42, 60}, {43, 46, 78}, {47, 47, 79}, {48, 65535, 78}, },
            {{0, 65535, -41}, },
            {},
            {{10, 10, 80}, },
            {{48, 102, -42}, },
            {{116, 116, 81}, },
            {{112, 112, 82}, },
            {{111, 111, 83}, },
            {},
            {{108, 108, 84}, },
            {{107, 107, 85}, },
            {{100, 100, 86}, },
            {{116, 116, 87}, },
            {{116, 116, 88}, },
            {{101, 101, 89}, },
            {{101, 101, 90}, },
            {{48, 57, 91}, {95, 95, 54}, {97, 122, 92}, },
            {},
            {{0, 41, 93}, {42, 42, 94}, {43, 65535, 93}, },
            {},
            {},
            {{114, 114, 95}, },
            {{101, 101, 96}, },
            {{114, 114, 97}, },
            {},
            {{97, 97, 98}, },
            {{117, 117, 99}, },
            {{101, 101, 100}, },
            {{97, 97, 101}, },
            {{110, 110, 102}, },
            {},
            {{48, 122, -78}, },
            {{48, 122, -78}, },
            {{0, 65535, -80}, },
            {{0, 41, 78}, {42, 42, 94}, {43, 65535, -62}, },
            {{97, 97, 103}, },
            {{114, 114, 104}, },
            {{101, 101, 105}, },
            {{103, 103, 106}, },
            {{99, 99, 107}, },
            {{115, 115, 108}, },
            {{120, 120, 109}, },
            {{115, 115, 110}, },
            {{99, 99, 111}, },
            {{115, 115, 112}, },
            {{100, 100, 113}, },
            {{101, 101, 114}, },
            {{116, 116, 115}, },
            {},
            {},
            {},
            {{116, 116, 116}, },
            {},
            {},
            {},
            {{105, 105, 117}, },
            {},
            {{111, 111, 118}, },
            {{110, 110, 119}, },
            {{115, 115, 120}, },
            {},
        }
        { // PACKAGE
            {{9, 9, 1}, {10, 10, 2}, {13, 13, 3}, {32, 32, 4}, {36, 36, 5}, {39, 39, 6}, {40, 40, 7}, {41, 41, 8}, {42, 42, 9}, {43, 43, 10}, {44, 44, 11}, {45, 45, 12}, {46, 46, 13}, {47, 47, 14}, {48, 48, 15}, {49, 57, 16}, {58, 58, 17}, {59, 59, 18}, {61, 61, 19}, {63, 63, 20}, {65, 65, 21}, {66, 71, 22}, {72, 72, 23}, {73, 73, 24}, {74, 77, 22}, {78, 78, 25}, {79, 79, 22}, {80, 80, 26}, {81, 82, 22}, {83, 83, 27}, {84, 84, 28}, {85, 90, 22}, {91, 91, 29}, {93, 93, 30}, {95, 95, 31}, {97, 122, 32}, {123, 123, 33}, {124, 124, 34}, {125, 125, 35}, },
            {{9, 32, -2}, },
            {{9, 32, -2}, },
            {{9, 9, 1}, {10, 10, 36}, {13, 32, -2}, },
            {{9, 32, -2}, },
            {{36, 36, 37}, {48, 57, 38}, {65, 90, 39}, {95, 95, 40}, {97, 122, 41}, },
            {{0, 9, 42}, {11, 12, 42}, {14, 38, 42}, {39, 39, 43}, {40, 65535, 42}, },
            {},
            {},
            {},
            {},
            {},
            {{62, 62, 44}, },
            {{46, 46, 45}, },
            {{42, 42, 46}, {47, 47, 47}, },
            {{48, 57, 16}, {88, 88, 48}, {120, 120, 49}, },
            {{48, 57, 16}, },
            {},
            {},
            {},
            {},
            {{36, 95, -7}, {97, 97, 41}, {98, 98, 50}, {99, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 95, -7}, {97, 100, 41}, {101, 101, 51}, {102, 122, 41}, },
            {{36, 95, -7}, {97, 102, 41}, {103, 103, 52}, {104, 122, 41}, },
            {{36, 100, -25}, {101, 101, 53}, {102, 116, 41}, {117, 117, 54}, {118, 122, 41}, },
            {{36, 95, -7}, {97, 113, 41}, {114, 114, 55}, {115, 122, 41}, },
            {{36, 95, -7}, {97, 115, 41}, {116, 116, 56}, {117, 120, 41}, {121, 121, 57}, {122, 122, 41}, },
            {{36, 95, -7}, {97, 110, 41}, {111, 111, 58}, {112, 113, 41}, {114, 114, 59}, {115, 122, 41}, },
            {},
            {},
            {{36, 122, -7}, },
            {{36, 36, 37}, {48, 57, 60}, {65, 90, 39}, {95, 95, 61}, {97, 122, 62}, },
            {},
            {},
            {},
            {{9, 32, -2}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{0, 9, 63}, {11, 12, 63}, {14, 38, 63}, {39, 39, 64}, {40, 65535, 63}, },
            {{39, 39, 65}, },
            {},
            {},
            {{0, 41, 66}, {42, 42, 67}, {43, 65535, 66}, },
            {{0, 9, 68}, {10, 10, 69}, {11, 12, 68}, {13, 13, 70}, {14, 65535, 68}, },
            {{48, 57, 71}, {65, 70, 71}, {97, 102, 71}, },
            {{48, 102, -50}, },
            {{36, 95, -7}, {97, 114, 41}, {115, 115, 72}, {116, 122, 41}, },
            {{36, 95, -7}, {97, 107, 41}, {108, 108, 73}, {109, 122, 41}, },
            {{36, 95, -7}, {97, 109, 41}, {110, 110, 74}, {111, 122, 41}, },
            {{36, 95, -7}, {97, 118, 41}, {119, 119, 75}, {120, 122, 41}, },
            {{36, 107, -53}, {108, 108, 76}, {109, 122, 41}, },
            {{36, 110, -30}, {111, 111, 77}, {112, 122, 41}, },
            {{36, 95, -7}, {97, 97, 78}, {98, 122, 41}, },
            {{36, 109, -54}, {110, 110, 79}, {111, 122, 41}, },
            {{36, 95, -7}, {97, 106, 41}, {107, 107, 80}, {108, 122, 41}, },
            {{36, 100, -25}, {101, 101, 81}, {102, 122, 41}, },
            {{36, 122, -34}, },
            {{36, 95, -7}, {97, 122, 82}, },
            {{36, 122, -34}, },
            {{0, 38, -44}, {39, 39, 83}, {40, 65535, 63}, },
            {},
            {},
            {{0, 65535, -48}, },
            {{0, 41, 84}, {42, 42, 67}, {43, 46, 84}, {47, 47, 85}, {48, 65535, 84}, },
            {{0, 65535, -49}, },
            {},
            {{10, 10, 86}, },
            {{48, 102, -50}, },
            {{36, 115, -29}, {116, 116, 87}, {117, 122, 41}, },
            {{36, 95, -7}, {97, 111, 41}, {112, 112, 88}, {113, 122, 41}, },
            {{36, 110, -30}, {111, 111, 89}, {112, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 107, -53}, {108, 108, 90}, {109, 122, 41}, },
            {{36, 95, -7}, {97, 99, 41}, {100, 100, 91}, {101, 122, 41}, },
            {{36, 115, -29}, {116, 116, 92}, {117, 122, 41}, },
            {{36, 115, -29}, {116, 116, 93}, {117, 122, 41}, },
            {{36, 100, -25}, {101, 101, 94}, {102, 122, 41}, },
            {{36, 100, -25}, {101, 101, 95}, {102, 122, 41}, },
            {{36, 36, 37}, {48, 57, 96}, {65, 95, -34}, {97, 122, 97}, },
            {},
            {{0, 41, 98}, {42, 42, 99}, {43, 65535, 98}, },
            {},
            {},
            {{36, 113, -28}, {114, 114, 100}, {115, 122, 41}, },
            {{36, 100, -25}, {101, 101, 101}, {102, 122, 41}, },
            {{36, 113, -28}, {114, 114, 102}, {115, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 95, -7}, {97, 116, 41}, {117, 117, 103}, {118, 122, 41}, },
            {{36, 100, -25}, {101, 101, 104}, {102, 122, 41}, },
            {{36, 95, -7}, {97, 97, 105}, {98, 122, 41}, },
            {{36, 109, -54}, {110, 110, 106}, {111, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 122, -84}, },
            {{36, 122, -84}, },
            {{0, 65535, -86}, },
            {{0, 41, 84}, {42, 42, 99}, {43, 65535, -69}, },
            {{36, 95, -7}, {97, 97, 107}, {98, 122, 41}, },
            {{36, 113, -28}, {114, 114, 108}, {115, 122, 41}, },
            {{36, 100, -25}, {101, 101, 109}, {102, 122, 41}, },
            {{36, 95, -7}, {97, 98, 41}, {99, 99, 110}, {100, 122, 41}, },
            {{36, 114, -52}, {115, 115, 111}, {116, 122, 41}, },
            {{36, 95, -7}, {97, 119, 41}, {120, 120, 112}, {121, 122, 41}, },
            {{36, 114, -52}, {115, 115, 113}, {116, 122, 41}, },
            {{36, 98, -105}, {99, 99, 114}, {100, 122, 41}, },
            {{36, 114, -52}, {115, 115, 115}, {116, 122, 41}, },
            {{36, 99, -79}, {100, 100, 116}, {101, 122, 41}, },
            {{36, 115, -29}, {116, 116, 117}, {117, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 115, -29}, {116, 116, 118}, {117, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 122, -7}, },
            {{36, 95, -7}, {97, 104, 41}, {105, 105, 119}, {106, 122, 41}, },
            {{36, 122, -7}, },
            {{36, 110, -30}, {111, 111, 120}, {112, 122, 41}, },
            {{36, 109, -54}, {110, 110, 121}, {111, 122, 41}, },
            {{36, 114, -52}, {115, 115, 122}, {116, 122, 41}, },
            {{36, 122, -7}, },
        }
    };*/

    private static final int[][] accept;
/*  {
        // NORMAL
        {-1, 38, 38, 38, 38, -1, 20, 21, 27, 24, 29, 25, 14, 30, 35, 35, 32, 16, 17, 26, -1, -1, -1, -1, 13, -1, 12, 18, 19, 33, 22, 28, 23, 38, -1, -1, 31, 15, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 33, -1, 33, -1, 34, 34, -1, -1, -1, 39, 39, 36, -1, -1, -1, 10, -1, -1, -1, -1, -1, -1, -1, 33, 37, -1, 39, 39, -1, -1, -1, 11, -1, -1, -1, -1, -1, 9, 33, 33, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, -1, 2, 8, 4, -1, 3, 5, 1, -1, 7, -1, -1, -1, 6, },
        // PACKAGE
        {-1, 38, 38, 38, 38, 0, -1, 20, 21, 27, 24, 29, 25, 14, 30, 35, 35, 32, 16, 17, 26, 0, 0, 0, 0, 0, 0, 0, 0, 18, 19, 0, 0, 22, 28, 23, 38, 0, 0, 0, 0, 0, -1, -1, 31, 15, -1, -1, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, 34, 34, -1, -1, -1, 39, 39, 36, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 37, -1, 39, 39, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, -1, -1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, },

    };*/

    public enum State
    {
        NORMAL,
        PACKAGE,
        ;

        public int id()
        {
            return this.ordinal();
        }
    }

    static
    {
        try
        {
            InputStream resStream = Lexer.class.getResourceAsStream("lexer.dat");
            if(resStream == null)
            {
                throw new RuntimeException("The file \"lexer.dat\" is missing.");
            }
            DataInputStream s = new DataInputStream(new BufferedInputStream(resStream));

            // read gotoTable
            int gotoTableLength1 = s.readInt();
            gotoTable = new int[gotoTableLength1][][][];
            for(int i = 0; i < gotoTableLength1; i++)
            {
                int gotoTableLength2 = s.readInt();
                gotoTable[i] = new int[gotoTableLength2][][];
                for(int j = 0; j < gotoTableLength2; j++)
                {
                    int gotoTableLength3 = s.readInt();
                    gotoTable[i][j] = new int[gotoTableLength3][3];
                    for(int k = 0; k < gotoTableLength3; k++)
                    {
                        for(int l = 0; l < 3; l++)
                        {
                            gotoTable[i][j][k][l] = s.readInt();
                        }
                    }
                }
            }

            // read accept
            int acceptLength1 = s.readInt();
            accept = new int[acceptLength1][];
            for(int i = 0; i < acceptLength1; i++)
            {
                int acceptLength2 = s.readInt();
                accept[i] = new int[acceptLength2];
                for(int j = 0; j < acceptLength2; j++)
                {
                    accept[i][j] = s.readInt();
                }
            }

            s.close();
        }
        catch(IOException e)
        {
            throw new RuntimeException("The file \"lexer.dat\" is either missing or corrupted.", e);
        }
    }
}
